# Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.

from cmf.monitor.json_metrics_utils import get_leaf_dict


class JsonParser(object):
  def __init__(self, json_dict):
    """
    May raise ParseError if the json structure is not what
    we expect.
    """
    self._json = json_dict
    self.jvm = get_leaf_dict(self._json, 'jvm', 'metrics')

#
# This is what the SNN json looks like:
#
SAMPLE = """
{
   "dfs":{
      "FSDirectory":[
         [
            {
               "hostName":"bigrig",
               "sessionId":""
            },
            {
               "files_deleted":14773
            }
         ]
      ]
   },
   "jvm":{
      "metrics":[
         [
            {
               "hostName":"bigrig",
               "processName":"SecondaryNameNode",
               "sessionId":""
            },
            {
               "gcCount":365,
               "gcTimeMillis":6418,
               "logError":0,
               "logFatal":0,
               "logInfo":7880,
               "logWarn":455,
               "maxMemoryM":910.25,
               "memHeapCommittedM":45.375,
               "memHeapUsedM":17.691422,
               "memNonHeapCommittedM":47.5625,
               "memNonHeapUsedM":23.627472,
               "threadsBlocked":1,
               "threadsNew":2,
               "threadsRunnable":3,
               "threadsTerminated":4,
               "threadsTimedWaiting":5,
               "threadsWaiting":6
            }
         ]
      ]
   },
   "ugi":{
      "ugi":[
         [
            {
               "hostName":"bigrig"
            },
            {
               "loginFailure_avg_time":0,
               "loginFailure_num_ops":0,
               "loginSuccess_avg_time":0,
               "loginSuccess_num_ops":0
            }
         ]
      ]
   }
}
"""
