// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/chart/spec/MockAnyChartStock",
	"cloudera/chart/AnyStockLineChartBase"
], function(MockAnyChartStock, AnyStockLineChartBase) {
describe("AnyStockLineChartBase Tests", function() {
	var subject, d1, d2, d3;

	beforeEach(function() {
		subject = new AnyStockLineChartBase({});
		d1 = new Date(2);
		d2 = new Date(10);
		d3 = new Date(10);
	});
	
	it("should find the minimum of two dates", function(){
		expect(subject.min(d1, d2)).toEqual(d1);
	});

	it("should find the maximum of two dates", function(){
		expect(subject.max(d1, d2)).toEqual(d2);
	});

	it("should find the average of two dates", function(){
		expect(subject.avg(d1, d2).getTime()).toEqual(new Date(6).getTime());
	});

	it("should find the delta of two dates", function(){
		expect(subject.delta(d1, d2)).toEqual(8);
	});

	it("should find the two different dates different", function() {
		expect(subject.same(d1, d2)).toEqual(false);
	});

	it("should find the two same dates same", function() {
		expect(subject.same(d2, d3)).toEqual(true);
	});

	it("should find the one date and one null different", function() {
		expect(subject.same(d1, null)).toEqual(false);
		expect(subject.same(null, d2)).toEqual(false);
	});

	it("should update the first and last visible date", function() {
		subject.zoomTo(d1, d2);
		expect(subject.same(subject.chart.firstVisibleDate, subject.toChartDate(d1))).toEqual(true);
		expect(subject.same(subject.chart.lastVisibleDate, subject.toChartDate(d2))).toEqual(true);
	});

	it("should convert to and back to the same date", function() {
		expect(subject.fromChartDate(subject.toChartDate(d1))).toEqual(d1);
	});
});
});
