// (c) Copyright 2012 Cloudera, Inc. All rights reserved.

define(["cloudera/logs/page/LogWithContext","cloudera/Util","cloudera/common/Humanize","cloudera/common/I18n"],function(e,t,n,r){describe("LogWithContext tests",function(){var i,s=function(e,t){return{logLevel:"WARN",message:"Test message",offset:e,path:"/test/path.log",roleId:null,source:"com.cloudera.cmf.event.publish.EventStorePublisherWIthRetry",time:t}},o=function(){var e,t=[];for(e=0;e<100;e++){var n=9e6-e*1e5,r=133495e7+e*1e6;t.push(s(n,r))}return{host:"testhost",port:9e3,success:!0,events:t}};beforeEach(function(){jasmine.Ajax.useMock(),i=new e({logEventUrl:"http://localhost/logEventUrl",downloadUrl:"http://localhost/downloadUrl",hostUrlPrefix:"http://localhost/hostUrlPrefix"}),spyOn(n,"getTimezoneDelta").andReturn(0)}),it("allows non-message columns to be collapsed and expanded",function(){$('<div class="nonMessageColumn"></div>').appendTo("body"),expect(i.tableCollapsed()).toEqual(!1),i.collapseColumns(),expect($(".nonMessageColumn").hasClass("hidden")).toEqual(!0),expect(i.tableCollapsed()).toEqual(!0),i.expandColumns(),expect($(".nonMessageColumn").hasClass("hidden")).toEqual(!1),expect(i.tableCollapsed()).toEqual(!1)}),it("has a hack for IE8 in there",function(){$("html").addClass("ie8");var e={style:{display:""}};i.$mainTable=[e],spyOn(window,"setTimeout"),i.collapseColumns(),expect(e.style.display).toEqual("inline-table"),expect(window.setTimeout).wasCalled()}),it("knows how to publish error events",function(){spyOn(jQuery,"publish"),i.showError("An error"),expect(jQuery.publish).wasCalledWith("showError",["An error"])}),it("publishes errors when receiving errors from the server",function(){spyOn(i,"showError"),spyOn(r,"t");var e={success:!1,message:"Another error!"},t=i.onLogResponse(function(){});t(e),expect(i.showError).wasCalled(),expect(r.t).wasCalled()}),it("should have a blank initial selectedEventIndex",function(){expect(i.selectedEventIndex()).toEqual(undefined)}),it("should scroll when the selected event changes",function(){spyOn(i,"scrollToIndex"),i.onSelectedEventIndexChanged(0),expect(i.scrollToIndex).wasCalledWith(0)}),it("should scroll to the bottom when first coming to the page",function(){var e=[1,2,3];spyOn(i,"events").andReturn(e),spyOn(i,"params").andReturn({}),spyOn(i,"scrollToIndex"),i.onSelectedEventIndexChanged(-1),expect(i.scrollToIndex).wasCalledWith(e.length-1)}),it("should calculate first offset from the first event",function(){i.firstEvent({offset:354}),expect(i.firstOffset()).toEqual(354)}),it("should not have problems generating first offset if there is no first event",function(){i.firstEvent(null),expect(i.firstOffset()).toEqual(0)}),it("should not have problems generating last offset if there is no last event",function(){i.lastEvent(null),expect(i.lastOffset()).toEqual(0)}),it("should calculate last offset from the last event",function(){i.lastEvent({offset:123}),expect(i.lastOffset()).toEqual(123)}),it("should calculate first formatted date from first event",function(){i.firstEvent({time:1334251763077}),expect(i.formattedFirstDate()).toEqual("April 12 2012 10:29 AM")}),it("should calculate last formatted date from last event",function(){i.lastEvent({time:1334957116e3}),expect(i.formattedLastDate()).toEqual("April 20 2012 2:25 PM")}),it("should not return a formatted date for zero first event time",function(){i.firstEvent({time:0}),expect(i.formattedFirstDate()).toEqual("")}),it("should not return a formatted date for zero last event time",function(){i.lastEvent({time:0}),expect(i.formattedLastDate()).toEqual("")}),it("should not have problems calculating first formatted date if first event is null",function(){i.firstEvent(null),expect(i.formattedFirstDate()).toEqual("")}),it("should not have problems calculating last formatted date if last event is null",function(){i.lastEvent(null),expect(i.formattedLastDate()).toEqual("")}),it("should display an error if the data is not valid",function(){spyOn(jQuery,"publish"),i.onLogResponse(function(){})('<div class="RegionContent">ExceptionReport</div>'),expect(jQuery.publish).wasCalled()}),it("should process events independent of what happens to them next",function(){var e=o();this.verifyEvents=function(t){expect(t.length).toEqual(e.events.length),expect(t[0].hasOwnProperty("highlighted")).toBeTruthy(),expect(t[0].highlighted).toBeFalsy()},spyOn(this,"verifyEvents").andCallThrough(),i.onLogResponse(this.verifyEvents)(e),expect(this.verifyEvents).wasCalled()}),it("should display every event and set the other dependent properties efficiently",function(){var e=t.filterError(o());spyOn(i.events,"push").andCallThrough(),spyOn(i,"params").andReturn({offset:e.events[3].offset}),i.onInitialResponse(e.events),expect(i.events.push.callCount).toEqual(0),expect(i.events()[0].offset).toEqual(9e6),expect(i.events().length).toEqual(e.events.length),expect(i.firstEvent().offset).toEqual(e.events[0].offset),expect(i.lastEvent().offset).toEqual(e.events[e.events.length-1].offset),expect(i.selectedEventIndex()).toEqual(3),expect(i.events()[3].highlighted).toBeTruthy(),expect(i.firstAccess).toEqual(!1)}),it("tracks the first row as a jQuery object",function(){spyOn(i.$mainTable,"find").andReturn("row"),i.firstEvent("thing"),expect(i.$mainTable.find.callCount).toEqual(1),expect(i.$mainTable.find.argsForCall[0]).toEqual(["tbody tr:first-child"])}),it("tracks the last row as a jQuery object",function(){spyOn(i.$mainTable,"find").andReturn("row"),i.lastEvent("thing2"),expect(i.$mainTable.find.callCount).toEqual(1),expect(i.$mainTable.find.argsForCall[0]).toEqual(["tbody tr:last-child"])}),it("prepends events correctly and sets dependent properties",function(){var e,t=[];for(e=0;e<3;e++)t.push(s(e+2,e+52));i.events(t),spyOn(i,"firstEvent"),i.$firstRow=$("tr"),spyOn(i.$firstRow,"position").andReturn({top:0});var n=s(0,50),r=s(1,51);spyOn(i,"preservePosition"),spyOn(i,"restorePosition"),i.prependEvents([n,r]),expect(n.clazz).toEqual(""),expect(r.clazz).toEqual(""),expect(i.firstEvent).wasCalledWith(n),expect(i.preservePosition).wasCalled(),expect(i.restorePosition).wasCalled();var o=i.events();expect(o.length).toEqual(5),expect(o[0]).toEqual(n),expect(o[1]).toEqual(r),expect(o[2]).toEqual(t[0])}),it("prepends events correctly when there are duplicates",function(){var e=[],t=[],n;for(n=0;n<3;n++)e.push(s(n,50+n)),t.push(s(n+1,51+n));i.events(t),i.$firstRow=$("tr"),spyOn(i.$firstRow,"position").andReturn({top:0}),spyOn(i,"preservePosition"),spyOn(i,"restorePosition"),i.prependEvents(e),expect(i.preservePosition).wasCalled(),expect(i.restorePosition).wasCalled();var r=i.events();expect(r.length).toEqual(4);for(n=0;n<4;n++)expect(r[n].offset).toEqual(n)}),it("appends events correctly and sets dependent properties",function(){var e,t=[];for(e=0;e<3;e++)t.push(s(e,e+50));i.events(t),spyOn(i,"lastEvent");var n=s(3,53),r=s(4,54);spyOn(i,"preservePosition"),spyOn(i,"restorePosition"),i.appendEvents([n,r]),expect(n.clazz).toEqual(""),expect(r.clazz).toEqual(""),expect(i.preservePosition).wasCalled(),expect(i.restorePosition).wasCalled(),expect(i.lastEvent).wasCalledWith(r);var o=i.events();expect(o.length).toEqual(5),expect(o[2].offset).toEqual(t[2].offset),expect(o[3]).toEqual(n),expect(o[4]).toEqual(r)}),it("appends events correctly when there are duplicates",function(){var e=[],t=[],n;for(n=0;n<3;n++)e.push(s(n,50+n)),t.push(s(n+1,51+n));i.events(e),spyOn(i,"preservePosition"),spyOn(i,"restorePosition"),i.appendEvents(t),expect(i.preservePosition).wasCalled(),expect(i.restorePosition).wasCalled();var r=i.events();expect(r.length).toEqual(4);for(n=0;n<4;n++)expect(r[n].offset).toEqual(n)}),it("displays a maximum number of events when prepending",function(){var t,n=4;i=new e({logEventUrl:"http://localhost/logEventUrl",downloadUrl:"http://localhost/downloadUrl",hostUrlPrefix:"http://localhost/hostUrlPrefix",maxEvents:n});var r=[],o=[];for(t=0;t<3;t++)r.push(s(1e3+t*10,1e4+t*1e3)),o.push(s(900+t*10,5e3+t*1e3));i.events(r),spyOn(i,"preservePosition"),spyOn(i,"restorePosition"),i.prependEvents(o);var u=i.events();expect(u.length).toEqual(n),expect(u[0].offset).toEqual(900),expect(u[1].offset).toEqual(910),expect(u[2].offset).toEqual(920),expect(u[3].offset).toEqual(1e3),expect(i.preservePosition).wasCalled(),expect(i.restorePosition).wasCalled()}),it("displays a maximum number of events when appending",function(){var t,n=4;i=new e({logEventUrl:"http://localhost/logEventUrl",downloadUrl:"http://localhost/downloadUrl",hostUrlPrefix:"http://localhost/hostUrlPrefix",maxEvents:n});var r=[],o=[];for(t=0;t<3;t++)r.push(s(900+t*10,5e3+t*1e3)),o.push(s(1e3+t*10,1e4+t*1e3));i.events(r),spyOn(i,"preservePosition"),spyOn(i,"restorePosition"),i.appendEvents(o);var u=i.events();expect(u.length).toEqual(n),expect(u[0].offset).toEqual(920),expect(u[1].offset).toEqual(1e3),expect(u[2].offset).toEqual(1010),expect(u[3].offset).toEqual(1020),expect(i.preservePosition).wasCalled(),expect(i.restorePosition).wasCalled()}),it("will only allow one in-flight request at a time",function(){var e=jasmine.createSpy();e.complete=function(){},spyOn($,"post").andReturn(e);var t=null;spyOn(e,"complete").andCallFake(function(){t=e.complete.mostRecentCall.args[0]}),i.requestInFlight=!1,i.makeRequest({}),expect($.post).wasCalled(),expect(e.complete).wasCalled(),expect(i.requestInFlight).toEqual(!0),expect(t).not.toBeFalsy(),i.makeRequest({}),t(),expect(i.requestInFlight).toEqual(!1),i.makeRequest({}),expect($.post.callCount).toEqual(2)}),it("will not make any server requests if not within a scroll threshold",function(){var e=jasmine.createSpy();e.height=function(){},spyOn(i.$mainTableContainer,"find").andReturn(e),spyOn(i.$mainTableContainer,"scrollTop").andReturn(500),spyOn(i.$mainTableContainer,"height").andReturn(100),spyOn(e,"height").andReturn(1e3),spyOn(i,"makeRequest"),i.onTableScroll(),expect(i.makeRequest).wasNotCalled()}),it("will make server requests using the top offset if within the top scroll threshold",function(){var e=jasmine.createSpy();e.height=function(){},spyOn(i.$mainTableContainer,"find").andReturn(e),spyOn(i.$mainTableContainer,"scrollTop").andReturn(0),spyOn(i.$mainTableContainer,"height").andReturn(100),spyOn(e,"height").andReturn(1e3),spyOn(i,"makeRequest"),i.onTableScroll(),expect(i.makeRequest).wasCalled()}),it("will make server requests using the bottom offset if within the bottom scroll threshold",function(){var e=jasmine.createSpy();e.height=function(){},spyOn(i.$mainTableContainer,"find").andReturn(e),spyOn(i.$mainTableContainer,"scrollTop").andReturn(900),spyOn(i.$mainTableContainer,"height").andReturn(100),spyOn(e,"height").andReturn(1e3),spyOn(i,"makeRequest"),i.onTableScroll(),expect(i.makeRequest).wasCalled()}),it("knows how to merge events when there are no new events",function(){var e=[],t=[s(0,1),s(2,3),s(4,5)],n=i.mergeEvents(e,t);expect(n.length).toEqual(3),expect(n[0].time).toEqual(1),expect(n[1].time).toEqual(3),expect(n[2].time).toEqual(5),n=i.mergeEvents(t,e),expect(n.length).toEqual(3),expect(n[0].time).toEqual(1),expect(n[1].time).toEqual(3),expect(n[2].time).toEqual(5)}),it("knows how to merge events when there is no overlap",function(){var e=[],t=[],n;for(n=0;n<3;n++)e.push(s(n,n+50)),t.push(s(n+3,n+53));var r=i.mergeEvents(e,t);expect(r.length).toEqual(6),expect(r[0].time).toEqual(50),expect(r[1].time).toEqual(51),expect(r[2].time).toEqual(52),expect(r[3].time).toEqual(53),expect(r[4].time).toEqual(54),expect(r[5].time).toEqual(55),r=i.mergeEvents(t,e),expect(r.length).toEqual(6),expect(r[0].time).toEqual(50),expect(r[1].time).toEqual(51),expect(r[2].time).toEqual(52),expect(r[3].time).toEqual(53),expect(r[4].time).toEqual(54),expect(r[5].time).toEqual(55)}),it("knows how to merge events when there is overlap and duplicates",function(){var e=[],t=[],n;for(n=0;n<4;n++)e.push(s(n,n+50)),t.push(s(n+2,n+52));var r=i.mergeEvents(e,t);expect(r.length).toEqual(6),expect(r[0].time).toEqual(50),expect(r[1].time).toEqual(51),expect(r[2].time).toEqual(52),expect(r[3].time).toEqual(53),expect(r[4].time).toEqual(54),expect(r[5].time).toEqual(55)})})})